"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.$password = exports.$random = exports.$uuidhashfile = exports.$uuidhash = exports.$hashfile = exports.$hash = exports.$crc32 = exports.$crc16 = exports.$decrypt = exports.$encrypt = exports.$commonInitializationVectorCopy = exports.$setCommonItializationVector = exports.$uuidVersion = exports.$uuid = exports.AES256 = exports.AES128 = exports.SHA1 = exports.MD5 = exports.SHA512 = exports.SHA384 = exports.SHA256 = void 0;
const fs_1 = require("fs");
const crypto = __importStar(require("crypto"));
const types_1 = require("./types");
const commons_1 = require("./commons");
const data_1 = require("./data");
const tscharset_1 = require("./tscharset");
const tsdata_1 = require("./tsdata");
const utils_1 = require("./utils");
const strings_1 = require("./strings");
const crypto_tables_1 = require("./crypto_tables");
exports.SHA256 = 'SHA256';
exports.SHA384 = 'SHA384';
exports.SHA512 = 'SHA512';
exports.MD5 = 'MD5';
exports.SHA1 = 'SHA1';
exports.AES128 = 'AES128';
exports.AES256 = 'AES256';
function $uuid(internalImplementation = false) {
    if (!internalImplementation) {
        try {
            return crypto.randomUUID();
        }
        catch (_a) {
            (0, utils_1.$logterm)('Warning:crypto.randomUUID() is not available');
        }
    }
    return _generateV4UUID(true);
}
exports.$uuid = $uuid;
function $uuidVersion(str) {
    const s = (0, strings_1.$ftrim)(str);
    if (!s.length) {
        return undefined;
    }
    if (types_1.uuidV4Regex.test(s)) {
        return types_1.UUIDv4;
    }
    if (types_1.uuidV1Regex.test(s)) {
        return types_1.UUIDv1;
    }
    return undefined;
}
exports.$uuidVersion = $uuidVersion;
const __TSNoSpecificIV = Buffer.from([3, 67, 0, 14, 2, 95, 191, 0, 217, 255, 7, 6, 1, 67, 13, 89]);
let __CommonInitializationVector = __TSNoSpecificIV;
function $setCommonItializationVector(d) { __CommonInitializationVector = (0, commons_1.$length)(d) === 16 ? (0, data_1.$bufferFromDataLike)(d) : __TSNoSpecificIV; }
exports.$setCommonItializationVector = $setCommonItializationVector;
function $commonInitializationVectorCopy() { return (0, data_1.$bufferFromBytes)(__CommonInitializationVector, { forceCopy: true }); }
exports.$commonInitializationVectorCopy = $commonInitializationVectorCopy;
function $encrypt(src, skey, opts) {
    const [charset, key, algo] = _charsetKeyAndAlgo(skey, opts);
    if (!charset) {
        return null;
    }
    const source = (0, commons_1.$isstring)(src) ? charset.uint8ArrayFromString(src) : (0, data_1.$uint8ArrayFromDataLike)(src);
    if (!(0, commons_1.$length)(source)) {
        return null;
    }
    let returnValue = null;
    try {
        const addIV = !(opts === null || opts === void 0 ? void 0 : opts.noInitializationVector);
        const iv = addIV ? crypto.randomBytes(16) : __CommonInitializationVector;
        const cipher = crypto.createCipheriv(algo, key, iv);
        let encrypted = addIV ? new tsdata_1.TSData(iv) : new tsdata_1.TSData();
        encrypted.appendBytes(cipher.update(source));
        encrypted.appendBytes(cipher.final());
        returnValue = !(opts === null || opts === void 0 ? void 0 : opts.dataOutput) ? encrypted.toString('hex') : encrypted;
    }
    catch (e) {
        console.log(e);
        returnValue = null;
    }
    return returnValue;
}
exports.$encrypt = $encrypt;
function $decrypt(source, skey, opts) {
    const hasVector = !(opts === null || opts === void 0 ? void 0 : opts.noInitializationVector);
    const isString = (0, commons_1.$isstring)(source);
    const len = (0, commons_1.$length)(source);
    if (len % (isString ? 32 : 16) !== 0 || len < (hasVector ? (isString ? 64 : 32) : (isString ? 32 : 16))) {
        return null;
    }
    const [charset, key, algo] = _charsetKeyAndAlgo(skey, opts);
    if (!charset) {
        return null;
    }
    let returnValue = null;
    try {
        let src;
        let iv;
        if (isString) {
            src = Buffer.from(hasVector ? source.slice(32) : source, 'hex');
            iv = hasVector ? Buffer.from(source.slice(0, 32), 'hex') : __CommonInitializationVector;
        }
        else {
            src = (0, data_1.$bufferFromDataLike)(source, { start: hasVector ? 16 : 0 });
            iv = hasVector ? (0, data_1.$bufferFromDataLike)(source, { end: 16 }) : __CommonInitializationVector;
        }
        let decipher = crypto.createDecipheriv(algo, key, iv);
        let decrypted = new tsdata_1.TSData(decipher.update(src));
        decrypted.appendBytes(decipher.final());
        returnValue = !(opts === null || opts === void 0 ? void 0 : opts.dataOutput) ? decrypted.toString(charset) : decrypted;
    }
    catch (e) {
        returnValue = null;
    }
    return returnValue;
}
exports.$decrypt = $decrypt;
function $crc16(source, encoding) { return _crc(source, 0, crypto_tables_1.__TSCRC16ARCTable, 0xffff, encoding) >>> 0; }
exports.$crc16 = $crc16;
function $crc32(source, encoding) { return (_crc(source, 0 ^ -1, crypto_tables_1.__TSCRC32Table, 0x00ffffff, encoding) ^ -1) >>> 0; }
exports.$crc32 = $crc32;
function $hash(buf, method, encoding) {
    let ret = null;
    try {
        const source = (0, commons_1.$isstring)(buf) ?
            (0, tscharset_1.$charset)(encoding, tscharset_1.TSCharset.binaryCharset()).uint8ArrayFromString(buf) :
            (0, data_1.$uint8ArrayFromDataLike)(buf);
        let hash = _createHash(method);
        hash.update(source);
        ret = hash.digest('hex');
    }
    catch (e) {
        ret = null;
    }
    return ret;
}
exports.$hash = $hash;
function $hashfile(filePath, method) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            let hash = _createHash(method);
            if (!(0, commons_1.$length)(filePath)) {
                return reject(null);
            }
            try {
                (0, fs_1.createReadStream)(filePath).on('data', data => hash.update(data)).on('end', () => resolve(hash.digest('hex')));
            }
            catch (e) {
                return reject(null);
            }
        });
    });
}
exports.$hashfile = $hashfile;
function $uuidhash(buf, version) { return _uuidHash($hash(buf, exports.MD5), version); }
exports.$uuidhash = $uuidhash;
function $uuidhashfile(filePath, version) {
    return __awaiter(this, void 0, void 0, function* () { return _uuidHash(yield $hashfile(filePath, exports.MD5), version); });
}
exports.$uuidhashfile = $uuidhashfile;
function $random(max) {
    let m = (0, commons_1.$unsigned)(max);
    if (!m) {
        m = types_1.UINT32_MAX;
    }
    return crypto.randomInt(Math.min(m, types_1.UINT_MAX));
}
exports.$random = $random;
;
function $password(len, opts = { hasLowercase: true }) {
    const MAX_CONSECUTIVE_CHARS = 2;
    const rand = crypto.randomInt;
    if (!opts.hasLowercase && !opts.hasNumeric && !opts.hasSpecials && !opts.hasUppercase) {
        opts.hasUppercase = true;
    }
    if (len < 3 || len > 256)
        return null;
    let base = '';
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasUppercase) {
        base = base + "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    }
    if (opts.hasNumeric) {
        base = base + "0123456789";
    }
    if (opts.hasLowercase && (rand(891) % 7)) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasSpecials) {
        base = base + "!#$-_&*@()+/";
    }
    if (opts.hasSpecials && (rand(1795) % 3)) {
        base = base + "-#@*!";
    }
    if (opts.hasNumeric && (rand(733) % 2)) {
        base = base + "0123456789";
    }
    if (opts.hasNumeric) {
        base = base + "0123456789";
    }
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    const charlen = base.length;
    let identicals = 0, i = 0;
    let last = '', password = '';
    while (i < len) {
        let c = base.charAt(rand(charlen));
        if (c == last) {
            if (++identicals == MAX_CONSECUTIVE_CHARS) {
                identicals--;
            }
            else {
                password = password + c;
                i++;
            }
            ;
        }
        else {
            last = c;
            identicals = 0;
            password = password + c;
            i++;
        }
    }
    return password;
}
exports.$password = $password;
Uint8Array.prototype.crc16 = function crc16() { return $crc16(this); };
Uint8Array.prototype.crc32 = function crc32() { return $crc32(this); };
Uint8Array.prototype.hash = function hash(method) { return $hash(this, method); };
Uint8Array.prototype.uuidhash = function uuidhash(version) { return $uuidhash(this, version); };
ArrayBuffer.prototype.crc16 = function crc16() { return $crc16(this); };
ArrayBuffer.prototype.crc32 = function crc32() { return $crc32(this); };
ArrayBuffer.prototype.hash = function hash(method) { return $hash(this, method); };
ArrayBuffer.prototype.uuidhash = function uuidhash(version) { return $uuidhash(this, version); };
const __TSEncryptKeyLength = {
    'AES128': 16,
    'AES256': 32
};
const __TSEncryptAlgoRef = {
    'AES128': 'aes-128-cbc',
    'AES256': 'aes-256-cbc'
};
const __TSHashMethodRef = {
    'SHA256': 'sha256',
    'SHA384': 'sha384',
    'SHA512': 'sha512',
    'MD5': 'md5',
    'SHA1': 'sha1'
};
function _uuidHash(h, version) {
    if ((0, commons_1.$length)(h) === 32) {
        const v = (0, commons_1.$value)(version, types_1.UUIDv1);
        const s = h.toLowerCase();
        return s.slice(0, 8) + '-' + s.slice(8, 12)
            + (v === types_1.UUIDv1 ? '-' + s.slice(12, 16) + '-' + s.slice(16, 20)
                : '-4' + s.slice(13, 16) + '-' + _hnab(s.charAt(16)) + s.slice(17, 20))
            + '-' + s.slice(20, 32);
    }
    return null;
}
function _algo(algo) {
    const a = (0, strings_1.$trim)(algo).toUpperCase();
    return (0, commons_1.$ok)(__TSEncryptKeyLength[a]) ? a : exports.AES256;
}
function _createHash(method) { return crypto.createHash((0, commons_1.$value)(__TSHashMethodRef[(0, strings_1.$trim)(method).toUpperCase()], 'sha256')); }
function _charsetKeyAndAlgo(skey, opts) {
    const defaultCharset = tscharset_1.TSCharset.binaryCharset();
    const keyCharset = (0, tscharset_1.$charset)(opts === null || opts === void 0 ? void 0 : opts.keyEncoding, defaultCharset);
    const algo = _algo(opts === null || opts === void 0 ? void 0 : opts.algorithm);
    const isKeyObject = skey instanceof crypto.KeyObject;
    let key = isKeyObject ?
        skey :
        ((0, commons_1.$isstring)(skey) ?
            keyCharset.uint8ArrayFromString(skey) :
            (0, data_1.$uint8ArrayFromDataLike)(skey));
    if (!isKeyObject && key.length !== __TSEncryptKeyLength[algo]) {
        return [null, key, __TSEncryptAlgoRef[exports.AES256]];
    }
    return [(0, tscharset_1.$charset)(opts === null || opts === void 0 ? void 0 : opts.encoding, defaultCharset), key, __TSEncryptAlgoRef[algo]];
}
function _hnab(c) { return '89ab'.includes(c) ? c : '8'; }
function _crc(source, crc, table, andValue, encoding) {
    const src = (0, commons_1.$isstring)(source) ?
        (0, tscharset_1.$charset)(encoding, tscharset_1.TSCharset.binaryCharset()).uint8ArrayFromString(source) :
        (0, data_1.$uint8ArrayFromDataLike)(source);
    const len = src.length;
    for (let i = 0; i < len; i++) {
        crc = ((crc >> 8) & andValue) ^ table[(crc ^ src[i]) & 0xff];
    }
    return crc;
}
function _generateV4UUID(convertToLowerCase) {
    let uuid = "";
    for (let i = 0; i < 32; i++) {
        if (i === 12) {
            uuid += '-4';
        }
        else {
            if (i === 8 || i === 16 || i === 20) {
                uuid += '-';
            }
            const rand = crypto.randomInt(16) | 0;
            uuid += (i == 16 ? (rand & 3 | 8) : rand).toHex1(convertToLowerCase);
        }
    }
    return uuid;
}
//# sourceMappingURL=crypto.js.map